﻿using Stimulsoft.Report;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace StimulsoftPageBug
{
    public partial class view : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                // load template 
                eViewer.Report = rptData.report(Server.MapPath("~"));
            }
        }

       


        protected void eViewer_ReportDesign(object sender, EventArgs e)
        {
            Response.Redirect("~/design.aspx");
        }


        Dictionary<int, string> _renderedPages = new Dictionary<int, string>();
        StiReport _report = null;
        protected void btnRender_Click(object sender, EventArgs e)
        {
            _report = rptData.report(Server.MapPath("~")); // get report with data
            _report.NumberOfPass = StiNumberOfPass.DoublePass; // single pass because it is needed
            _report.Compile();
            _report.CompiledReport.Rendering += _report_Rendering; // attach event
            _report.RenderedPages.PageAdded += RenderedPages_PageAdded;

            _report.Render(false);

            _report.Rendering -= _report_Rendering;
            _report.RenderedPages.PageAdded -= RenderedPages_PageAdded;

            /* check here for variable values:
            myVar should be in following sequence:
            Page_1
            Page_1
            Page_2
            Page_2
            Page_1
            Page_1
            Page_2
            Page_2

            actual otuput is:
            Page_4
            Page_4
            Page_1
            Page_1
            Page_2
            Page_2
            Page_1
            Page_1



               */
            // "re-display" report
            eViewer.Report = rptData.report(Server.MapPath("~"));
        }

        private void RenderedPages_PageAdded(object sender, EventArgs e)
        {
            if (!_report.CompiledReport.IsSecondPass)
                return;
            _renderedPages.Add(_renderedPages.Count + 1, "PADD: " + (_report.CompiledReport["PageNumber"].ToString()) + "|" + _report.CompiledReport["myVar"].ToString()); // + "|" + _report.StatusString + "|" + _report.RenderedPages.Count.ToString());
        }
 
        private void _report_Rendering(object sender, EventArgs e)
        {
            if (!_report.CompiledReport.IsSecondPass)
                return;

            _renderedPages.Add(_renderedPages.Count + 1, "PREN: " + (_report.CompiledReport["PageNumber"].ToString()) + "|" + _report.CompiledReport["myVar"].ToString()); // + "|" + _report.StatusString + "|" + _report.RenderedPages.Count.ToString());
        }
    }
}